Name:		signal-desktop
Version:	1.19.0
Release:	1%{?dist}
Summary:	Private messaging from your desktop
License:	GPLv3
URL:		https://github.com/signalapp/Signal-Desktop/

#			https://updates.signal.org/desktop/apt/pool/main/s/signal-desktop/signal-desktop_1.3.0_amd64.deb
Source0:	https://github.com/signalapp/Signal-Desktop/archive/v%{version}.tar.gz

#ExclusiveArch:	x86_64
BuildRequires: binutils, git, python2, gcc, gcc-c++, yarn, openssl-devel, bsdtar, jq
BuildRequires: nodejs, ca-certificates

#Depends: gconf2, gconf-service, libnotify4, libappindicator1, libxtst6, libnss3, libasound2, libxss1
Requires:   GConf2, libnotify, libappindicator, libXtst, nss

%description
Private messaging from your desktop

%prep
pwd
rm -rf Signal-Desktop-%{version}
tar xfz %{S:0}
cd Signal-Desktop-%{version}

# allow node 10
# sed -i 's/"node": "^8.9.3"/"node": ">=8.9.3"/' package.json

# + avoid using fedora's node-gyp
#yarn --no-default-rc add --dev node-gyp

%build
cd Signal-Desktop-%{version}

node --version

# avoid using fedora's node-gyp
# npm install node-gyp


# patch @journeyapps/sqlcipher to nuke binaries
# try and use a local copy of sqlcipher based on the original one
yarn --ignore-engines --no-default-rc add --force @journeyapps/sqlcipher
d=.tmp-ja-sqlc
rm -rf "$d"
mkdir "$d"
cp -pR node_modules/@journeyapps/sqlcipher "$d"
jq \
	'del(.bundledDependencies)|. * {"scripts":{"install":"node-pre-gyp install --build-from-source"}}' \
	$d/sqlcipher/package.json  >.$$ \
    && mv .$$ $d/sqlcipher/package.json
# purge cache just in case (we didn't change version)
rm -rf $(yarn --no-default-rc cache dir)/npm-@journeyapps/sqlcipher-*
yarn --ignore-engines --no-default-rc add --force file://$(realpath $d/sqlcipher)

# build assets (icons), then RPM - building a plain directory loses the later install paths
yarn --no-default-rc generate --force --ignore-engines

yarn --no-default-rc --verbose build-release --linux rpm

%install

# Electron directory of the final build depends on the arch
%ifnarch x86_64
    %global PACKDIR linux-ia32-unpacked
%else
    %global PACKDIR linux-unpacked
%endif

bsdtar xf %{_builddir}/Signal-Desktop-%{version}/release/signal-desktop-*.rpm -C %{buildroot}


# create symlink
install -dm755 %{buildroot}%{_bindir}/
ln -s /opt/Signal/signal-desktop %{buildroot}%{_bindir}/signal-desktop

#use tray file
patch -p0 %{buildroot}//usr/share/applications/signal-desktop.desktop<<'EOF'
4c4
< Exec="/opt/Signal/signal-desktop" %U
---
> Exec=env XDG_CURRENT_DESKTOP=Unity /usr/bin/signal-desktop --use-tray-icon %U
EOF

%files
%defattr(-,root,root)
/usr/share/icons/hicolor/*/apps/signal-desktop.png
/usr/share/applications/signal-desktop.desktop
/opt/Signal
%{_bindir}/signal-desktop


%changelog
* Thu Dec 13 2018 Guilherme Cardoso <gjc@ua.pt> 1.19.0-1
 - Version bump

* Tue Nov 27 2018 Guilherme Cardoso <gjc@ua.pt> 1.18.1-1
 - Version bump

* Thu Nov 15 2018 Guilherme Cardoso <gjc@ua.pt> 1.18.0-1
 - Version bump

* Sun Nov 04 2018 Guilherme Cardoso <gjc@ua.pt> 1.17.3-1
 - Version bump

* Wed Oct 31 2018 Guilherme Cardoso <gjc@ua.pt> 1.17.2-1
 - Version bump
 - Explicit nodejs dependency, which tries to solve the requirement of having nodejs LTS version 8
 - Thanks clime for the help

* Fri Oct 26 2018 Guilherme Cardoso <gjc@ua.pt> 1.17.1-1
 - Version bump

* Mon Oct 22 2018 Guilherme Cardoso <gjc@ua.pt> 1.16.3-4
 - Fix wrong this rpmspec version info

* Mon Oct 15 2018 Guilherme Cardoso <gjc@ua.pt> 1.16.2-3
  - Workaround for KDE plasma Signal's tray icon
  https://github.com/signalapp/Signal-Desktop/issues/1876

* Fri Oct 12 2018 Guilherme Cardoso <gjc@ua.pt> 1.16.2-2
  - Patch to use tray icon

* Mon Sep 24 2018 Guilherme Cardoso <gjc@ua.pt> 1.16.2-1
  - Version bump

* Tue Sep 18 2018 Guilherme Cardoso <gjc@ua.pt> 1.16.1-1
  - Version bump

* Thu Sep 06 2018 Guilherme Cardoso <gjc@ua.pt> 1.16.0-1
  - Version bump

* Fri Aug 17 2018 Guilherme Cardoso <gjc@ua.pt> 1.15.5-2
  - Try to patch to allow higher node versions for Fedora Rawhide
  - Manual symlink

* Thu Aug 16 2018 Matthias Andree <mandree@FreeBSD.org> 1.15.5-1
  - Shuffle things around a bit
  - Add jq to build requisites
  - tweak %files section so it actually finds its inputs
  - add node-gyp to developer dependencies only
  - add -no-default-rc to yarn calls throughout

* Tue Aug 14 2018 Guilherme Cardoso <gjc@ua.pt> 1.15.4-1
  - Version bump
  - Build fixes arround embebed OpenSSL's from mandree and stemid
  Link:
  https://github.com/signalapp/Signal-Desktop/issues/2634

* Sat Aug 04 2018 Guilherme Cardoso <gjc@ua.pt> 1.15.0-1
  - Version bump

* Mon Jul 23 2018 Guilherme Cardoso <gjc@ua.pt> 1.14.4-1
  - Version bump

* Thu Jul 19 2018 Guilherme Cardoso <gjc@ua.pt> 1.14.2-1
  - Version bump

* Sun Jul 15 2018 Guilherme Cardoso <gjc@ua.pt> 1.14.1-1
  - Version bump

* Fri Jun 22 2018 Guilherme Cardoso <gjc@ua.pt> 1.13.0-1
  - Version bump

* Fri Jun 15 2018 Guilherme Cardoso <gjc@ua.pt> 1.12.1-1
  - Version bump

* Fri Jun 1 2018 Guilherme Cardoso <gjc@ua.pt> 1.12.0-1
  - Version bump

* Tue May 15 2018 Guilherme Cardoso <gjc@ua.pt> 1.11.0-1
  - Version bump

* Fri May 11 2018 Guilherme Cardoso <gjc@ua.pt> 1.10.1-1
  - Version bump

* Thu May 10 2018 Guilherme Cardoso <gjc@ua.pt> 1.10.0-1
  - Version bump

* Wed May 02 2018 Guilherme Cardoso <gjc@ua.pt> 1.9.0-1
  - Version bump
  - Spec file cleanup

* Thu Apr 26 2018 Guilherme Cardoso <gjc@ua.pt> 1.8.0-1
  - Version bump

* Mon Apr 16 2018 Guilherme Cardoso <gjc@ua.pt> 1.7.1-4
  - Added a few more yarn steps (check, lint)

* Mon Apr 16 2018 Guilherme Cardoso <gjc@ua.pt> 1.7.1-3
  - Fix build. Requires 'yarn transpile'. Thanks spacekookie.
  Ref: https://github.com/signalapp/Signal-Desktop/issues/2256

* Sat Apr 14 2018 Guilherme Cardoso <gjc@ua.pt> 1.7.1-2
  - Remove patch lowering nodejs due to async problems
  - Simplified BuildRequires

* Sat Apr 14 2018 Guilherme Cardoso <gjc@ua.pt> 1.7.1-1
  - Version Bump

* Thu Apr 12 2018 Guilherme Cardoso <gjc@ua.pt> 1.7.0-1
  - Version Bump

* Wed Apr 11 2018 Guilherme Cardoso <gjc@ua.pt> 1.6.1-2
  - Fix desktop shortcut (thanks to bol for reporting)

* Fri Mar 16 2018 Guilherme Cardoso <gjc@ua.pt> 1.6.1-1
  - Version bump

* Tue Mar 13 2018 Guilherme Cardoso <gjc@ua.pt> 1.6.0-1
  - Version bump
  - Update project homepage url
  - Patch to override nodejs version of Signal's sources

* Fri Mar 2 2018 Guilherme Cardoso <gjc@ua.pt> 1.5.2-1
  - Version bump

* Thu Mar 1 2018 Guilherme Cardoso <gjc@ua.pt> 1.5.1-1
  - Version bump

* Tue Feb 27 2018 Guilherme Cardoso <gjc@ua.pt> 1.5.0-1
  - Version bump

* Sun Feb 18 2018 Guilherme Cardoso <gjc@ua.pt> 1.3.0-2
  - Build from sources instead of unpacking .deb release

* Mon Feb 05 2018 Guilherme Cardoso <gjc@ua.pt> 1.3.0-1
  - Version bump
  - Added missing dependencies from original deb package

* Thu Nov 9 2017 Richard Monk <richardmonk@gmail.com> 1.0.37-1
  - Version bump

* Thu Nov 02 2017 Richard Monk <richardmonk@gmail.com> 1.0.35-1
  - Initial Packaging
